From b3a5c8da92452d4a300576981a0625646651b81c Mon Sep 17 00:00:00 2001
From: Nicolas Dandrimont <olasd@softwareheritage.org>
Date: Sat, 24 Nov 2018 14:53:27 +0100
Subject: [PATCH 2/3] Add some environment variables when running
 git-receive-pack

---
 .../DiffusionGitReceivePackSSHWorkflow.php    | 34 +++++++++++++++++++
 1 file changed, 34 insertions(+)

--- a/phabricator/src/applications/diffusion/ssh/DiffusionGitReceivePackSSHWorkflow.php
+++ b/phabricator/src/applications/diffusion/ssh/DiffusionGitReceivePackSSHWorkflow.php
@@ -89,6 +89,40 @@
     return $err;
   }
 
+  public function getEnvironment() {
+    $env = parent::getEnvironment();
+
+    $repository = $this->getRepository();
+    foreach($repository->toDictionary() as $key => $value) {
+      if(is_string($value)) {
+        $env['PHABRICATOR_REPO_' . strtoupper($key)] = $value;
+      }
+    }
+
+    $io_readwrite = PhabricatorRepositoryURI::IO_READWRITE;
+    $protocol_ssh = PhabricatorRepositoryURI::BUILTIN_PROTOCOL_SSH;
+
+    $uris = $repository->getURIs();
+    foreach ($uris as $uri) {
+      if ($uri->getIsDisabled()) {
+        continue;
+      }
+
+      if ($uri->getDefaultIOType() != $io_readwrite) {
+        continue;
+      }
+
+      if ($uri->getBuiltinProtocol() != $protocol_ssh) {
+        continue;
+      }
+
+      $env['PHABRICATOR_REPO_PUSH_URI'] = (string)$uri->getDisplayURI();
+      break;
+    }
+
+    return $env;
+  }
+
   private function executeRepositoryCommand($command) {
     $repository = $this->getRepository();
     $command = PhabricatorDaemon::sudoCommandAsDaemonUser($command);
